## MmGdbusModemFirmware MmGdbusModemFirmware — Generated C code for the org.freedesktop.ModemManager1.Modem.Firmware D-Bus interface |

## Functions

GVariant * | mm_gdbus_modem_firmware_dup_update_settings ()
GVariant * | mm_gdbus_modem_firmware_get_update_settings ()
void | mm_gdbus_modem_firmware_call_list ()
gboolean | mm_gdbus_modem_firmware_call_list_finish ()
gboolean | mm_gdbus_modem_firmware_call_list_sync ()
void | mm_gdbus_modem_firmware_call_select ()
gboolean | mm_gdbus_modem_firmware_call_select_finish ()
gboolean | mm_gdbus_modem_firmware_call_select_sync ()

## Properties

GVariant * | update-settings | Read / Write

## Signals

gboolean | handle-list | Run Last
gboolean | handle-select | Run Last

## Types and Values

| MmGdbusModemFirmware
struct | MmGdbusModemFirmwareIface

## Object Hierarchy

        GInterface
        ╰── MmGdbusModemFirmware

## Prerequisites

MmGdbusModemFirmware requires GObject.

## Known Implementations

MmGdbusModemFirmware is implemented by MMModemFirmware, MmGdbusModemFirmwareProxy and MmGdbusModemFirmwareSkeleton.

## Description

This section contains code for working with the org.freedesktop.ModemManager1.Modem.Firmware D-Bus interface in C.

## Functions

### mm_gdbus_modem_firmware_dup_update_settings ()

    GVariant *
    mm_gdbus_modem_firmware_dup_update_settings
                                   (MmGdbusModemFirmware *object);

Gets a copy of the "UpdateSettings" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemFirmware. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_modem_firmware_get_update_settings ()

    GVariant *
    mm_gdbus_modem_firmware_get_update_settings
                                   (MmGdbusModemFirmware *object);

Gets the value of the "UpdateSettings" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_firmware_dup_update_settings()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemFirmware. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_firmware_call_list ()

    void
    mm_gdbus_modem_firmware_call_list (MmGdbusModemFirmware *proxy,
                                       GCancellable *cancellable,
                                       GAsyncReadyCallback callback,
                                       gpointer user_data);

Asynchronously invokes the `List()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_firmware_call_list_finish()` to get the result of the operation.

See `mm_gdbus_modem_firmware_call_list_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemFirmwareProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_firmware_call_list_finish ()

    gboolean
    mm_gdbus_modem_firmware_call_list_finish
                                   (MmGdbusModemFirmware *proxy,
                                    gchar **out_selected,
                                    GVariant **out_installed,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_firmware_call_list()`.

#### Parameters

proxy | A MmGdbusModemFirmwareProxy. |
out_selected | Return location for return parameter or `NULL` to ignore. | [out][optional]
out_installed | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_firmware_call_list()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_firmware_call_list_sync ()

    gboolean
    mm_gdbus_modem_firmware_call_list_sync
                                   (MmGdbusModemFirmware *proxy,
                                    gchar **out_selected,
                                    GVariant **out_installed,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `List()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_firmware_call_list()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemFirmwareProxy. |
out_selected | Return location for return parameter or `NULL` to ignore. | [out][optional]
out_installed | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_firmware_call_select ()

    void
    mm_gdbus_modem_firmware_call_select (MmGdbusModemFirmware *proxy,
                                         const gchar *arg_uniqueid,
                                         GCancellable *cancellable,
                                         GAsyncReadyCallback callback,
                                         gpointer user_data);

Asynchronously invokes the `Select()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_firmware_call_select_finish()` to get the result of the operation.

See `mm_gdbus_modem_firmware_call_select_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemFirmwareProxy. |
arg_uniqueid | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_firmware_call_select_finish ()

    gboolean
    mm_gdbus_modem_firmware_call_select_finish
                                   (MmGdbusModemFirmware *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_firmware_call_select()`.

#### Parameters

proxy | A MmGdbusModemFirmwareProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_firmware_call_select()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_firmware_call_select_sync ()

    gboolean
    mm_gdbus_modem_firmware_call_select_sync
                                   (MmGdbusModemFirmware *proxy,
                                    const gchar *arg_uniqueid,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Select()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_firmware_call_select()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemFirmwareProxy. |
arg_uniqueid | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

## Types and Values

### MmGdbusModemFirmware

    typedef struct _MmGdbusModemFirmware MmGdbusModemFirmware;

Abstract interface type for the D-Bus interface org.freedesktop.ModemManager1.Modem.Firmware.

### struct MmGdbusModemFirmwareIface

    struct MmGdbusModemFirmwareIface {
      GTypeInterface parent_iface;

      gboolean (*handle_list) (
        MmGdbusModemFirmware *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_select) (
        MmGdbusModemFirmware *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_uniqueid);

      GVariant * (*get_update_settings) (MmGdbusModemFirmware *object);
    };

Virtual table for the D-Bus interface org.freedesktop.ModemManager1.Modem.Firmware.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_list` () | Handler for the “handle-list” signal. |
`handle_select` () | Handler for the “handle-select” signal. |
`get_update_settings` () | Getter for the “update-settings” property. |

## Property Details

### The `“update-settings”` property

      “update-settings”          GVariant *

Represents the D-Bus property "UpdateSettings".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemFirmware

Flags: Read / Write

Allowed values: GVariant<(ua{sv})>

Default value: NULL

## Signal Details

### The `“handle-list”` signal

    gboolean
    user_function (MmGdbusModemFirmware  *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `List()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_firmware_complete_list()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemFirmware. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-select”` signal

    gboolean
    user_function (MmGdbusModemFirmware  *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_uniqueid,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Select()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_firmware_complete_select()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemFirmware. |
invocation | A GDBusMethodInvocation. |
arg_uniqueid | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last